'-------------------------------------------------------------------------------
': I2C DS1307   ATmega8
': 1.2
':  
' :     RTC   MAXIM,
'         I2C.
' :18.08.2010-01:01
'---------------------------_--------------------------------
$regfile = "m8def.dat"
$crystal = 8000000
'----------------------------_-----------------------------------
Config Lcdbus = 4
Config Lcdpin = Pin , Rs = Portb.1 , E = Portb.2 , Db4 = Portb.0 , Db5 = Portd.7 , Db6 = Portd.6 , Db7 = Portd.5
Config Lcd = 16 * 2
Cursor Off
Cls
'--------------------------------------------------------------------------
'------------I2C---------------------
Config Sda = Portc.4
Config Scl = Portc.5
'------------------------------
Config Clock = User
Config Date = Dmy , Separator = .
Set Portd.0
Set Portd.1
Set Portc.3
Set Portc.2
Cn Alias Pind.1                                             '
Cv Alias Pind.0                                             '
Vv Alias Pinc.3                                             '
M Alias Pinc.2                                              '
Config 1wire = Portd.2                                      ',    DS18B20
Config Pind.4 = Output                                      ',    
Spkr Alias Pind.4
'-----------------------_-------------------------------
$lib "mcsbyte.lbx"
$lib "ds1307clock.lib"
'----------------------------------------------------------------------
Const Ds1307w = &HD0
Const Ds1307r = &HD1
'-----------------------------_----------------------------
Deflcdchar 0 , 31 , 31 , 24 , 24 , 24 , 24 , 24 , 24        ' 1 
Deflcdchar 1 , 31 , 31 , 3 , 3 , 3 , 3 , 3 , 3              ' 2 
Deflcdchar 2 , 24 , 24 , 24 , 24 , 24 , 24 , 31 , 31        ' 3 
Deflcdchar 3 , 3 , 3 , 3 , 3 , 3 , 3 , 31 , 31              ' 4 
Deflcdchar 4 , 31 , 31 , 24 , 24 , 24 , 24 , 31 , 31        ' 5 
Deflcdchar 5 , 31 , 31 , 3 , 3 , 3 , 3 , 31 , 31            ' 6 
Deflcdchar 6 , 32 , 32 , 32 , 32 , 32 , 32 , 31 , 31        ' 7 
Deflcdchar 7 , 31 , 31 , 32 , 32 , 32 , 32 , 32 , 32        ' 8 
'---------------------------------------------------------------------
Dim J1 As Byte
Dim M1 As Byte
Dim D1 As Byte
Dim H1 As Byte
Dim Min1 As Byte
Dim Aa As Byte
Dim X1 As Byte
Dim Weekday As Byte
Dim Pos As Byte
Dim Digit As Byte
Dim Incoming As String * 8
Dim I As Byte
Dim Stroka As String * 8
Dim Style As Byte
Dim Byte0 As Byte
Dim Byte1 As Byte
Dim Signtemperatura As String * 1
Dim Temp As Byte
Dim Faren0 As Single
Dim Faren As Byte
Dim T2 As Byte
Dim Celsium As String * 5
Dim Fahrenhei As String * 5
'----------------------------------------------------------------------
Declare Sub Enterdatetime()
Declare Sub Getkey()
Declare Sub Menu()
Declare Sub Digit
Declare Sub Style
Declare Sub Style1
Declare Sub Style2
Declare Sub Style3
Declare Sub Style4
Declare Sub Minus
Declare Sub Plus
Declare Sub Gettemp
'-----------------------------c__---------------------------
Style = 1                                                   '  
Sound Spkr , 1000 , 500
Do
Call Gettemp
Call Style
If M = 0 Then
  Gosub Menu
End If

If Cn = 0 Then
  Gosub Minus
End If

If Cv = 0 Then
  Gosub Plus
End If
Loop
End
'-------------------------------------------------------------------------------
Sub Minus
Sound Spkr , 100 , 800
Cls
Style = Style - 1
If Style <= 0 Then Style = 1
Waitms 100
End Sub
'-------------------------------------------------------------------------------
Sub Plus
Sound Spkr , 100 , 800
Cls
Style = Style + 1
If Style > 4 Then Style = 4
Waitms 100
End Sub
'-------------------------------------------------------------------------------
Sub Style
Select Case Style
Case 1 : Call Style1
Case 2 : Call Style2
Case 3 : Call Style3
Case 4 : Call Style4
End Select
End Sub
'-------------------------------------------------------------------------------
Sub Style1
Locate 1 , 1
Lcd Time$ ; "  " ; Celsium
Locate 2 , 1
Lcd Date$ ; "  " ; Fahrenhei
End Sub
'-------------------------------------------------------------------------------
Sub Style2
Pos = 2
Incoming = Time$
For I = 1 To 8
Stroka = Mid(incoming , I , 1)
Call Digit
Next I
End Sub
'-------------------------------------------------------------------------------
Sub Style3
Pos = 2
Incoming = Date$
For I = 1 To 8
Stroka = Mid(incoming , I , 1)
Call Digit
Next I
End Sub
'-------------------------------------------------------------------------------
Sub Style4
Pos = 1
Incoming = Celsium + Fahrenhei
For I = 1 To 8
Stroka = Mid(incoming , I , 1)
Call Digit
Next I
End Sub
'-------------------------------------------------------------------------------
Getdatetime:
  I2cstart                                                  ' Generate start code
  I2cwbyte Ds1307w                                          ' 
  I2cwbyte 0                                                '   1307
  I2cstart                                                  ' Generate start code
  I2cwbyte Ds1307r                                          ' 
  I2crbyte _sec , Ack                                       '
  I2crbyte _min , Ack                                       '
  I2crbyte _hour , Ack                                      '
  I2crbyte Weekday , Ack                                    ' 
  I2crbyte _day , Ack                                       '
  I2crbyte _month , Ack                                     '
  I2crbyte _year , Nack                                     '
  I2cstop
  _sec = Makedec(_sec) : _min = Makedec(_min) : _hour = Makedec(_hour)
  _day = Makedec(_day) : _month = Makedec(_month) : _year = Makedec(_year)
Return
Setdate:
  _day = Makebcd(_day) : _month = Makebcd(_month) : _year = Makebcd(_year)
  I2cstart                                                  ' Generate start code
  I2cwbyte Ds1307w                                          ' send address
  I2cwbyte 4                                                ' starting address in 1307
  I2cwbyte _day                                             ' Send Data to SECONDS
  I2cwbyte _month                                           ' MINUTES
  I2cwbyte _year                                            ' Hours
  I2cstop
Return
Settime:
  _sec = Makebcd(_sec) : _min = Makebcd(_min) : _hour = Makebcd(_hour)
  I2cstart                                                  ' Generate start code
  I2cwbyte Ds1307w                                          ' send address
  I2cwbyte 0                                                ' starting address in 1307
  I2cwbyte _sec                                             ' Send Data to SECONDS
  I2cwbyte _min                                             ' MINUTES
  I2cwbyte _hour                                            ' Hours
  I2cstop
Return
End
'-------------------------------------------------------------------------------
Sub Enterdatetime()
   Cls
   'X1 = 08
   Aa = 0
   X1 = _year
   Do
   If X1 > 50 Then X1 = 9
   If X1 < 9 Then X1 = 50
   Locate 1 , 1
   Lcd "[> Setup date <]"
   Locate 2 , 1
   Lcd "Set year: " ; X1 ; "  "
   Getkey
   J1 = X1
   Loop Until Aa = 1
'-------------------------------------------
   Cls
   Aa = 0
   'X1 = 11
   X1 = _month
   Do
   If X1 > 12 Then X1 = 1
   If X1 < 1 Then X1 = 12
   Locate 1 , 1
   Lcd "[> Setup date <]"
   Locate 2 , 1
   Lcd "Set month: " ; X1 ; "  "
   Getkey
   M1 = X1
   Loop Until Aa = 1
'-------------------------------------------
   Cls
   Aa = 0
   'X1 = 1
   X1 = _day
   Do
   If X1 > 31 Then X1 = 1
   If X1 < 1 Then X1 = 31
   Locate 1 , 1
   Lcd "[> Setup date <]"
   Locate 2 , 1
   Lcd "Set day: " ; X1 ; "  "
   Getkey
   D1 = X1
   Loop Until Aa = 1
   _year = J1
   _month = M1
   _day = D1
   Gosub Setdate
'-------------------------------------------
   Cls
   Aa = 0
   'X1 = 12
   X1 = _hour
   Do
   If X1 > 23 Then X1 = 0
   If X1 < 0 Then X1 = 23
  Locate 1 , 1
   Lcd "[> Setup time <]"
   Locate 2 , 1
   Lcd "Set hours: " ; X1 ; "  "
   Getkey
   H1 = X1
   Loop Until Aa = 1
'-------------------------------------------
   Cls
   Aa = 0
   'X1 = 30
   X1 = _min
   Do
   If X1 > 59 Then X1 = 0
   If X1 < 1 Then X1 = 59
   Locate 1 , 1
   Lcd "[> Setup time <]"
   Locate 2 , 1
   Lcd "Set minutes: " ; X1 ; " "
   Getkey
   Min1 = X1
   Loop Until Aa = 1

   _hour = H1
   _min = Min1
   _sec = 0
   Gosub Settime
End Sub
'-------------------------------------------------------------------------------
Sub Getkey()
   Waitms 300
   If Cv = 0 Then Incr X1
    If Cn = 0 Then Decr X1
   If Vv = 0 Then
   Aa = 1
   Else
   Aa = 0
   End If
End Sub
'-------------------------------------------------------------------------------
Sub Menu()
Sound Spkr , 100 , 800
Aa = 0
X1 = 0
Getkey
Enterdatetime
Cls
End Sub
End
'-------------------------------------------------------------------------------
Sub Gettemp
1wreset
1wwrite &HCC                                                '    
1wwrite &H44                                                '  
Waitms 750                                                  '   
1wreset
1wwrite &HCC
1wwrite &HBE                                                '    
Byte0 = 1wread()                                            '   
Byte1 = 1wread()                                            '   
If Byte1 >= 248 Then                                        '    .248   - 11111000  .    -   &HFF
Byte0 = &HFF - Byte0
Byte1 = &HFF - Byte1
Signtemperatura = "-"
Else
Signtemperatura = "+"
End If
Temp = Byte0 / 16                                           '      4  (2*2*2*2=16)
T2 = Byte1 * 16                                             '      4  (2*2*2*2=16)
Temp = Temp + T2                                            '       .  LCD      
Faren0 = Temp * 1.8
Faren = Faren0 + 32
Celsium = Signtemperatura + Str(temp) + "C"
Fahrenhei = Signtemperatura + Str(faren) + "F "
End Sub
'--------------------------------------------------------------------------
Sub Digit:
Select Case Stroka
Case "0":
Locate 1 , Pos
Lcd Chr(0) ; Chr(1)
Locate 2 , Pos
Lcd Chr(2) ; Chr(3)
'--------------------------------------
Case "1":
Locate 1 , Pos
Lcd Chr(1) ; " "
Locate 2 , Pos
Lcd Chr(3) ; Chr(6)
'--------------------------------------
Case "2":
Locate 1 , Pos
Lcd Chr(6) ; Chr(5)
Locate 2 , Pos
Lcd Chr(2) ; Chr(6)
'--------------------------------------
Case "3":
Locate 1 , Pos
Lcd Chr(7) ; Chr(5)
Locate 2 , Pos
Lcd Chr(6) ; Chr(3)
'--------------------------------------
Case "4":
Locate 1 , Pos
Lcd Chr(2) ; Chr(3)
Locate 2 , Pos
Lcd Chr(7) ; Chr(1)
'--------------------------------------
Case "5":
Locate 1 , Pos
Lcd Chr(4) ; Chr(6)
Locate 2 , Pos
Lcd Chr(6) ; Chr(3)
'--------------------------------------
Case "6":
Locate 1 , Pos
Lcd Chr(4) ; Chr(6)
Locate 2 , Pos
Lcd Chr(2) ; Chr(3)
'--------------------------------------
Case "7":
Locate 1 , Pos
Lcd Chr(0) ; Chr(1)
Locate 2 , Pos
Lcd " " ; Chr(1)
'--------------------------------------
Case "8":
Locate 1 , Pos
Lcd Chr(4) ; Chr(5)
Locate 2 , Pos
Lcd Chr(2) ; Chr(3)
'--------------------------------------
Case "9":
Locate 1 , Pos
Lcd Chr(4) ; Chr(5)
Locate 2 , Pos
Lcd " " ; Chr(3)
'--------------------------------------
Case ":":
Locate 1 , Pos
Lcd "o"
Locate 2 , Pos
Lcd "o"
Pos = Pos - 1
'--------------------------------------
Case ".":
Locate 1 , Pos
Lcd " "
Locate 2 , Pos
Lcd "o"
Pos = Pos - 1
'--------------------------------------
Case "C":
Locate 1 , Pos
Lcd Chr(0) ; Chr(7)
Locate 2 , Pos
Lcd Chr(2) ; Chr(6)
'--------------------------------------
Case "F":
Locate 1 , Pos
Lcd Chr(0) ; Chr(7)
Locate 2 , Pos
Lcd Chr(0) ; Chr(7)
'--------------------------------------
Case "+":
Locate 1 , Pos
Lcd " " ; " "
Locate 2 , Pos
Lcd " " ; " "
'--------------------------------------
Case "-":
Locate 1 , Pos
Lcd Chr(6) ; Chr(6)
Locate 2 , Pos
Lcd " " ; " "
End Select
Pos = Pos + 2
End Sub
'-------------------------------------------------------------------------------